/**
 *
 */
package edu.agh.xml2006.task5;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * @author Kuba Madej
 *
 */
public class Include {
	private DocumentBuilder builder;

	private String rootFileName;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Include(args[0]).run();
	}

	public Include(final String fileName) {
		rootFileName = fileName;
		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory
					.newInstance();
			factory.setValidating(false);

			builder = factory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			throw new RuntimeException(e);
		}
	}

	private void run() {
		Document doc = makeInclusions(rootFileName);

		Source source = new DOMSource(doc);

		Result result = new StreamResult(System.out);

		Transformer xformer;
		try {
			xformer = TransformerFactory.newInstance().newTransformer();
			xformer.transform(source, result);
		} catch (TransformerConfigurationException e) {
			throw new RuntimeException(e);
		} catch (TransformerFactoryConfigurationError e) {
			throw new RuntimeException(e);
		} catch (TransformerException e) {
			throw new RuntimeException(e);
		}
	}

	private Document makeInclusions(final String fileName) {
		Document doc = null;
		try {
			doc = builder.parse(new File(fileName));
		} catch (SAXException e) {
			throw new RuntimeException(e);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		NodeList list = doc.getElementsByTagName("include");
		for (int i = 0; i < list.getLength(); i++) {
			Element element = (Element) list.item(i);
			final String includeFileName = element.getAttribute("filename");
			if (includeFileName != null && !"".equals(includeFileName)) {
				element.getParentNode().replaceChild(
						doc.importNode(makeInclusions(includeFileName)
								.getDocumentElement(), true), element);
			}
		}
		return doc;
	}
}
