 /**
 *
 */
package edu.agh.xml2006.task6;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 * @author Kuba Madej
 *
 */
public class Split {
	private DocumentBuilder builder;

	private String rootFileName;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Split(args[0]).run();
	}

	public Split(final String fileName) {
		rootFileName = fileName;
		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory
					.newInstance();
			factory.setValidating(false);

			builder = factory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			throw new RuntimeException(e);
		}
	}

	private void run() {
		int outputFileNo = 1;

		Document doc;
		try {
			doc = builder.parse(new File(rootFileName));
		} catch (SAXException e1) {
			throw new RuntimeException(e1);
		} catch (IOException e1) {
			throw new RuntimeException(e1);
		}

		final NodeList nodes = doc.getDocumentElement().getChildNodes();

		for (int i = 0; i < nodes.getLength(); i++) {
			final Node node = nodes.item(i);
			if (node instanceof Element) {
				Element element = (Element) node;
				Document document = builder.newDocument();
				document.appendChild(document.importNode(element, true));

				Source source = new DOMSource(document);

				Result result = new StreamResult(new File(outputFileNo++
						+ ".xml"));

				Transformer xformer;
				try {
					xformer = TransformerFactory.newInstance().newTransformer();
					xformer.transform(source, result);
				} catch (TransformerConfigurationException e) {
					throw new RuntimeException(e);
				} catch (TransformerFactoryConfigurationError e) {
					throw new RuntimeException(e);
				} catch (TransformerException e) {
					throw new RuntimeException(e);
				}
			}
		}
	}
}
