<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2005/02/xpath-functions" xmlns:xdt="http://www.w3.org/2005/02/xpath-datatypes">
	
					<xsl:key name="pokoje" match="/baza/grupa/osoba" use="@pokoj"/>
					<xsl:template match="baza">
		<html>
			<head>
				<title>Baza danych pracowników</title>
			</head>
			<body>
				<xsl:for-each select="grupa">
					<a>
						<xsl:attribute name="href" select="concat('#', @nazwa)"/>
						<xsl:value-of select="@nazwa"/>
					</a>
					<br/>
				</xsl:for-each>
				<br/>
				<xsl:apply-templates select="*"/>
				<br/>
				Liczba osób: <xsl:value-of select="count(*/osoba)"/><br/><br/>
				Funkcje:
				<ul>
					<xsl:for-each select="grupa/osoba/funkcja">
						<xsl:variable name="funkcja" select="."/>
						<xsl:variable name="pos" select="position()"/>
						<xsl:if test="count((/baza/grupa/osoba/funkcja)[position() &lt; number($pos) and . = $funkcja]) = 0">
							<li>
								<xsl:attribute name="id" select="$funkcja"/>
								<xsl:value-of select="$funkcja"/>: <xsl:value-of select="count(/baza/grupa/osoba/funkcja[. = $funkcja])"/>
								<xsl:text> (</xsl:text>
								<xsl:variable name="z_funkcja" select="count(/baza/grupa/osoba[funkcja = $funkcja])"/>
								<xsl:for-each select="/baza/grupa/osoba[funkcja = $funkcja]">
									<xsl:sort select="@nazwisko"/>
									<xsl:value-of select="@nazwisko"/>
									<xsl:if test="position() &lt; $z_funkcja">
										<xsl:text>, </xsl:text>
									</xsl:if>
								</xsl:for-each>
								<xsl:text>)</xsl:text>
							</li>
						</xsl:if>
					</xsl:for-each>
				</ul>
				Stanowiska:
				<ul>
					<li>
						<xsl:variable name="z_mgr" select="count(grupa/osoba[ends-with(@nazwisko, ' mgr')])"/>
						mgr: <xsl:value-of select="$z_mgr"/>
						<xsl:text> (</xsl:text>
						<xsl:for-each select="grupa/osoba[ends-with(@nazwisko, ' mgr')]">
							<xsl:sort select="@nazwisko"/>
							<xsl:value-of select="substring-before(@nazwisko, ' mgr')"/>
							<xsl:if test="position() &lt; $z_mgr">
								<xsl:text>, </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>)</xsl:text>
					</li>
					<li>
						<xsl:variable name="z_mgr_inz" select="count(grupa/osoba[ends-with(@nazwisko, ' mgr inż.')])"/>
						mgr inż.: <xsl:value-of select="$z_mgr_inz"/>
						<xsl:text> (</xsl:text>
						<xsl:for-each select="grupa/osoba[ends-with(@nazwisko, ' mgr inż.')]">
							<xsl:sort select="@nazwisko"/>
							<xsl:value-of select="substring-before(@nazwisko, ' mgr inż.')"/>
							<xsl:if test="position() &lt; $z_mgr_inz">
								<xsl:text>, </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>)</xsl:text>
					</li>
					<li>
						<xsl:variable name="z_dr_hab" select="count(grupa/osoba[ends-with(@nazwisko, ' dr hab.')])"/>
						dr hab.: <xsl:value-of select="$z_dr_hab"/>
						<xsl:text> (</xsl:text>
						<xsl:for-each select="grupa/osoba[ends-with(@nazwisko, ' dr hab.')]">
							<xsl:sort select="@nazwisko"/>
							<xsl:value-of select="substring-before(@nazwisko, ' dr hab.')"/>
							<xsl:if test="position() &lt; $z_dr_hab">
								<xsl:text>, </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>)</xsl:text>
					</li>
					<li>
						<xsl:variable name="z_prof" select="count(grupa/osoba[ends-with(@nazwisko, ' prof.')])"/>
						prof.: <xsl:value-of select="$z_prof"/>
						<xsl:text> (</xsl:text>
						<xsl:for-each select="grupa/osoba[ends-with(@nazwisko, ' prof.')]">
							<xsl:sort select="@nazwisko"/>
							<xsl:value-of select="substring-before(@nazwisko, ' prof.')"/>
							<xsl:if test="position() &lt; $z_prof">
								<xsl:text>, </xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>)</xsl:text>
					</li>
				</ul>
				Liczba pokoi: <xsl:call-template name="licz_pokoje"/>
				<ul>
					<xsl:for-each-group select="grupa/osoba" group-by="@pokoj">
						<li>
							<xsl:attribute name="id" select="@pokoj"/>
							<xsl:value-of select="@pokoj"/>: <xsl:for-each select="current-group()">
								<xsl:sort select="@nazwisko"/>
								<xsl:value-of select="@nazwisko"/>
								<xsl:if test="position() &lt; count(current-group())">, </xsl:if>
							</xsl:for-each>
						</li>
					</xsl:for-each-group>
				</ul>
			</body>
		</html>
	</xsl:template>
	<xsl:template match="grupa">
		<table border="1">
			<xsl:attribute name="id" select="@nazwa"/>
			<tbody>
				<tr>
					<td colspan="4">
						<b>
							<div align="center">
								<font color="red" size="+1">
									<xsl:value-of select="@nazwa"/>
								</font>
							</div>
						</b>
					</td>
				</tr>
				<tr>
					<td>
						<b>
							<div align="center">
								Kto
							</div>
						</b>
					</td>
					<td>
						<b>
							<div align="center">
								Gdzie
							</div>
						</b>
					</td>
					<td>
						<b>
							<div align="center">
								Funkcje
							</div>
						</b>
					</td>
					<td>
						<b>
							<div align="center">
								Telefon
							</div>
						</b>
					</td>
				</tr>
				<xsl:for-each select="osoba">
					<xsl:sort select="@nazwisko"/>
					<xsl:apply-templates select="."/>
				</xsl:for-each>
			</tbody>
		</table>
		<br/>
	</xsl:template>
	<xsl:template match="osoba">
		<tr>
			<td valign="top">
				<xsl:value-of select="@nazwisko"/>
			</td>
			<td valign="top">
				<a>
					<xsl:attribute name="href" select="concat('#', @pokoj)"/>
					<xsl:value-of select="@pokoj"/>
				</a>
			</td>
			<td>
				<xsl:choose>
					<xsl:when test="count(funkcja) != 0">
						<xsl:for-each select="funkcja">
							<a>
								<xsl:attribute name="href" select="concat('#', .)"/>
								<xsl:value-of select="."/>
							</a>
							<br/>
						</xsl:for-each>
					</xsl:when>
					<xsl:otherwise>
						brak
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td valign="top">
				<xsl:choose>
					<xsl:when test="count(telefon) != 0">
						<xsl:for-each select="telefon">
							<xsl:value-of select="."/>
						</xsl:for-each>
					</xsl:when>
					<xsl:otherwise>
						brak
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</xsl:template>
	<xsl:template name="licz_pokoje">
		<xsl:param name="liczba" select="0"/>
		<xsl:param name="ktory" select="1"/>
		<xsl:choose>
			<xsl:when test="(grupa/osoba)[$ktory]">
				<xsl:variable name="aktualny" select="(grupa/osoba)[$ktory]/@pokoj"/>
				<xsl:choose>
					<xsl:when test="every $osoba in (grupa/osoba)[position() &lt; $ktory] satisfies $osoba/@pokoj != $aktualny">
						<xsl:call-template name="licz_pokoje">
							<xsl:with-param name="liczba" select="$liczba+1"/>
							<xsl:with-param name="ktory" select="$ktory+1"/>
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="licz_pokoje">
							<xsl:with-param name="liczba" select="$liczba"/>
							<xsl:with-param name="ktory" select="$ktory+1"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$liczba"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
